game = gideros.class(Sprite)

require "box2d"

local clock = os.clock

score = 0

function game: onEnterFrame()

	application:setBackgroundColor(0x00ff0)
	
  -- edit the step values if required. These are good defaults!
    self.world:step(1/25, 8, 3)
    --iterate through all child sprites
    for i = 1, self:getNumChildren() do
        --get specific sprite
        local sprite = self:getChildAt(i)
        -- check if sprite HAS a body (ie, physical object reference we added)
        if sprite.body then
            --update position to match box2d world object's position
            --get physical body reference
            local body = sprite.body
            --get body coordinates
            local bodyX, bodyY = body:getPosition()
            --apply coordinates to sprite
            sprite:setPosition(bodyX, bodyY)
            --apply rotation to sprite
            sprite:setRotation(body:getAngle() * 180 / math.pi)
        end
    end
	
	
end

function game:onExitBegin()
  self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
  self:removeEventListener(Event.ENTER_FRAME, self.pipemove)
  self:removeEventListener(Event.ENTER_FRAME, self.collide)
  self:removeEventListener(Event.ENTER_FRAME, self.scoreCount)
end

function game:init()

yes = true

    self.world = b2.World.new(0, 10, true)
     
    --set up screen dimensions
    screenW = application:getContentWidth()
    screenH = application:getContentHeight()
     
	--create background
	local bg = Sprite.new()
	local bgimg = Bitmap.new(Texture.new("Pictures/BG.png"))
	bg:setPosition(0,0)
	bg:setScale(screenW/400,screenH/500)
	bg:addChild(bgimg)
	self:addChild(bg)
	 
	 --add barriers
    self:wall(0,screenH/2,10,screenH)
    self:wall(screenW/2,0,screenW,10)
    self:wall(screenW,screenH/2,10,screenH)
    self:wall(screenW/2,screenH,screenW,10)
	 
    --create the spud
    self:ball(100, 100)
	
	self:pipecreate(self)
	
	score = 0
	
	scoreText = TextField.new(nil,score)
	scoreText:setPosition(0,height/15)
	scoreText:setScale(4,4)
	self:addChild(scoreText)
	
	local res = dataSaver.loadValue("highscore")
	if res == nil then
		print("no file")
		dataSaver.saveValue("highscore", 0)
	end
	hiscore = res
	
	hiscoreText = TextField.new(nil,hiscore)
	hiscoreText:setPosition(0,0)
	hiscoreText:setScale(4,4)
	self:addChild(hiscoreText)
	
	
	stage:addEventListener(Event.APPLICATION_SUSPEND, function()
    dataSaver.saveValue("highscore", hiscore )
	end)
	
	stage:addEventListener(Event.APPLICATION_EXIT, function()
    dataSaver.saveValue("highscore", hiscore )
	end)
	
	self:addEventListener(Event.ENTER_FRAME, self.scoreCount)
	self:addEventListener(Event.ENTER_FRAME, self.collide)
    self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
    self:addEventListener("exitBegin", self.onExitBegin, self)
end


function game:pipecreate(s)

	self:pipe(1000,250,0)
	self:pipe2(1060,100,180)

end

function force(self)
	self:applyLinearImpulse(0, -10, ball:getX(), ball:getY())
end

function game:ball(x, y)
	--width = 32
	--height = 27.5
    --create spud picture
    ball = Bitmap.new(Texture.new("Pictures/potatoTrans.png"))
    ball:setAnchorPoint(0.5,0.5)
     
    ball:setPosition(x,y)
	
	ball:setScale(0.5,0.5)
     
    --get radius
    local radius = ball:getWidth()/2
     
    --create box2d physical object
    body = self.world:createBody{type = b2.DYNAMIC_BODY}
    body:setPosition(ball:getX(), ball:getY())
    body:setAngle(ball:getRotation() * math.pi/180)
    local circle = b2.CircleShape.new(0, 0, radius)
    local fixture = body:createFixture{shape = circle, density = 1.0, 
    friction = 0.1, restitution = 0}
    ball.body = body
    ball.body.type = "ball"
	
	self:addEventListener(Event.MOUSE_DOWN, force, ball.body)
	 
    --add to scene
    self:addChild(ball)
	 
    --return created object
    return ball
end

function game:wall(x, y, width, height)
    local wall = Shape.new()
    wall:beginPath()
    
	--create shape
    wall:moveTo(-width/2,-height/2)
    wall:lineTo(width/2, -height/2)
    wall:lineTo(width/2, height/2)
    wall:lineTo(-width/2, height/2)
    wall:closePath()
    wall:endPath()
    wall:setPosition(x,y)
    
	--create body
    local body = self.world:createBody{type = b2.STATIC_BODY}
    body:setPosition(wall:getX(), wall:getY())
    body:setAngle(wall:getRotation() * math.pi/180)
    local poly = b2.PolygonShape.new()
    poly:setAsBox(wall:getWidth()/2, wall:getHeight()/2)
    local fixture = body:createFixture{shape = poly, density = 1.0, 
    friction = 0.1, restitution = 0}
    wall.body = body
    wall.body.type = "wall"
    
    self:addChild(wall)
    
    return wall
end

function game:pipe(x,y,r)
	
	pipe = Bitmap.new(Texture.new("Pictures/ForkTrans.png",true))
	pipe:setPosition(x,y)
	pipe:setScale(0.5,1)
	pipe:setRotation(r)
	self:addChild(pipe)
	
	pipe:addEventListener(Event.ENTER_FRAME,game.pipemove)
	
	return pipe
end

function game:pipe2(x,y,r)
	
	pipe2 = Bitmap.new(Texture.new("Pictures/ForkTrans.png",true))
	pipe2:setPosition(x,y)
	pipe2:setScale(0.5,1)
	pipe2:setRotation(r)
	self:addChild(pipe2)
	
	pipe2:addEventListener(Event.ENTER_FRAME,game.pipemove)
	
	return pipe2
end

function game:pipemove()
--width = 32
--height = 27.5
	rand = math.random(150,400)
	
	x0 = pipe:getX()
	y0 = pipe:getY()
	if yes then
	pipe:setPosition(x0-2,y0)
	end
	
	x1 = pipe2:getX()
	y1 = pipe2:getY()
	if yes then
	pipe2:setPosition(x1-2,y1)
	end
	
	pipescrn = width*1.6
	pipescrn2 = height/8
	randgap = height/3.2
	
	if x0 == 200 then
		yes = false
	end
	
	if x0 == -50 then
		pipe:setPosition(pipescrn,rand)
		pipe2:setPosition(pipescrn + pipescrn2,rand - randgap)
	end
	
end

function game:collide()

	--if collision(pipe,ball) then
		--print("yeah")
		--sceneManager:changeScene("results", 0.5, SceneManager.moveFromRight, easing.outBack)
	--end
	
	if ball:getY() > pipe:getY() - ball:getHeight()/2 then
		if pipe:getX() < 100 + ball:getWidth()/2 then
			if pipe:getX() > pipe:getWidth() then
				print ("Uh huh")
				sceneManager:changeScene("results", 0.3, SceneManager.moveFromRight, easing.outBack)
				dataSaver.saveValue("highscore", hiscore)
			end
		end
	end
	
	if ball:getY() < pipe2:getY() + ball:getHeight()/2 then
		if pipe:getX() < 100 + ball:getWidth()/2 then
			if pipe:getX() > pipe:getWidth() then
				print ("Uh huh")
				sceneManager:changeScene("results", 0.3, SceneManager.moveFromRight, easing.outBack)
				dataSaver.saveValue("highscore", hiscore)
			end
		end
	end

end

function game:scoreCount()

	if pipe:getX() == 40 then
		score = score + 1
		scoreText:setText(score)
	end
	
	if score > hiscore then
		hiscore = score
	end
	
	hiscoreText:setText(hiscore)
	hiscoreText:setPosition(width - hiscoreText:getWidth(), height/15)
	
end